package com.diagbot.mapper;

import java.util.List;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.diagbot.dto.ConceptBaseDTO;
import com.diagbot.dto.ConceptRes;
import com.diagbot.dto.ConceptWithOrderRes;
import com.diagbot.dto.GetAllInformationDTO;
import com.diagbot.dto.GetAllLisConceptDTO;
import com.diagbot.entity.Concept;
import com.diagbot.entity.wrapper.ConceptWrapper;
import com.diagbot.vo.GetAllInformationVO;
import com.diagbot.vo.GetAllLisConceptVO;
import com.diagbot.vo.IndexVO;

/**
 * <p>
 * Mapper 接口
 * </p>
 *
 * @author Weixuan Huang
 * @since 2019-01-30
 */
public interface ConceptMapper extends BaseMapper<Concept> {
	
	IPage<GetAllInformationDTO> getAllInformation(GetAllInformationVO getAllInformationVO);

    /**
     * 获取所有化验公表项
     *
     * @param getAllLisConceptVO
     * @return
     */
    List<GetAllLisConceptDTO> getAllLisConcept(GetAllLisConceptVO getAllLisConceptVO);

    /**
     * 获取概念-关系-概念
     *
     * @param conceptWrapper 查询参数
     * @return 起点术语和终点术语
     */
    List<ConceptRes> getConcept(ConceptWrapper conceptWrapper);

    /**
     * 获取带排序概念-关系-概念
     *
     * @param conceptWrapper 查询参数
     * @return 起点术语和终点术语以及排序号
     */
    List<ConceptWithOrderRes> getConceptWithOrder(ConceptWrapper conceptWrapper);



    /**
     * 检索
     *
     * @param indexVO 查询参数
     * @return 检索结果
     */
    List<ConceptBaseDTO> index(IndexVO indexVO);
    
}
